#pragma once

#include <stdio.h>
#include <stdlib.h>

#include <string>

// #define DEBUG

#ifdef DEBUG
#define LOG_DEBUG(format, ...) \
  printf("[%s:%d->%s]" format, __FILE__, __LINE__, __func__, ##__VA_ARGS__)
#else
#define LOG_DEBUG(format, ...) "LOG_DEBUG 未启用."
#endif

#define ASSERT(bool_expr, msg)                 \
  if ((bool_expr) == false) {                  \
    LOG_DEBUG(" : assert failed : %s\n", msg); \
    exit(-1);                                  \
  }
